package gov.cms.hh.v05024;

import gov.cms.hh.claim.ClaimIF;
import gov.cms.hh.data.meta.enumer.EditId_EN;
import gov.cms.hh.diagnosis.DiagnosisIF;
import gov.cms.hh.grouper.DataManagerIF;
import gov.cms.hh.logic.processor.HippsPosition4;

/**
 *
 * @author CMS
 */
public class HippsPosition4_v05024 extends HippsPosition4 {

    /**
     *
     * @param claim
     * @param dataManager
     */
    public HippsPosition4_v05024(ClaimIF claim, DataManagerIF dataManager) {
        super(claim, dataManager);
    }

    /**
     *
     * @return
     */
    @Override
    public boolean calculate() {
        boolean ret_flag = super.calculate();

        boolean alreadyAdded = false; // to prevent dups messaging for SDXs

        for (DiagnosisIF sdx : getClaim().getSecondaryDiagnoses().getCollection()) {
            // Add message for detail report if PDX gets substituted
            if (sdx.getEditCollection().hasEditId(EditId_EN.VALUE_SUBSTITUTED_FOR_SPAN)) {
                if(!alreadyAdded) {
                    addHippsLogicMessage(EditId_EN.VALUE_HIPPS4, EditId_EN.DATE_SPAN.getDescription());
                    alreadyAdded = true;
                }
                String text = "SDX = " + sdx.getValue() + " (" + sdx.getDescription() + "), "
                        + EditId_EN.VALUE_SUBSTITUTED_FOR_SPAN.getDescription();
                addHippsLogicMessage(EditId_EN.VALUE_HIPPS4, text);
            }
        }
        return ret_flag;
    }

}
